% This code returns possible strict dominators for a given source and destination
% node in a directed graph
clearvars;
clc;
tic
global A s t G

a = importdata('Wiki-Vote.txt');
A = a.data;

% fileID = fopen('Wiki-Vote (2).txt');
% C = textscan(fileID,'%f %f');
% fclose(fileID);
% A = cell2mat(C);

s1 = A(:,1).';
t1 = A(:,2).';

Nm = unique(A).';% Nm = Nodes matrix
if Nm(1,1) == 0
    disp('Because node 0 is present, 1 is added to all node id_s.');
    s = s1+1;
    t = t1+1;
    Nm = Nm+1;
else
    s = s1;
    t = t1;    
end

G = digraph(s,t);

source_node = 116;
target_node = 151;

B = bfsearch(G,source_node);
p = sum(B(:,1)==target_node);
if p == 0
    X1 = ['Source node: ',mat2str(source_node)];
    disp(X1);
    X2 = ['Target node: ',mat2str(target_node)];
    disp(X2);
    disp('No path exists between given two nodes.');
else
    X1 = ['Source node: ',mat2str(source_node)];
    disp(X1);
    X2 = ['Target node: ',mat2str(target_node)];
    disp(X2);
    s_path = shortestpath(G,source_node,target_node);% s_path = shortest path
    X3 = ['Shortest path is: ',mat2str(s_path)];
    disp(X3);
    
    q1 = source_node;
    D1 = [];
    while q1 ~= target_node
        f1 = function_for_dominators(q1,target_node);
        D1 = [D1 f1(1,1)];
        q1 = f1(1,1);
    end

    temp_matrix = s;
    s = t;
    t = temp_matrix;
    G = digraph(s,t);
    
    temp_id = source_node;
    source_node = target_node;
    target_node = temp_id;

    q2 = source_node;
    D2 = [];
    while q2 ~= target_node
        f2 = function_for_dominators(q2,target_node);
        D2 = [D2 f2(1,1)];
        q2 = f2(1,1);
    end

    D = intersect(D1,D2);
    if isempty(D) == 1
        X4 = 'Possible strict dominators: None';
        disp(X4);
    else
        X4 = ['Possible strict dominators: ',mat2str(D)];
        disp(X4);
    end
end
toc